//  
// cdcanl.C
//
// 

TFile *foutp;

int cdcanl(Int_t run = 0)
{
  gROOT->Reset();
  
  if( strncmp(gSystem->HostName(),"ccjlc",5)  != 0 ) {
    if( strncmp(gSystem->Getenv("OSTYPE"),"hpux",4) == 0 ) {
      gSystem->Load("../../../lib/libCDCUtils.sl");
      gSystem->Load("../../../lib/libCDCRawData.sl");
    }
    else {
      gSystem->Load("../../../lib/libCDCUtils.so");
      gSystem->Load("../../../lib/libCDCRawData.so");
    }
  }
    
  JSFSteer *jsf = new JSFSteer();

  foutp = new TFile("jsf.root","RECREATE"); //  Output file.
  TFile & fout = *foutp;
  
  if (!run) run = jsf->Env()->GetValue("JSFSteer.RunNo",36);  
  Char_t fname[64];
  // sprintf(fname,"run%4.4d.root",run);
//  sprintf(fname,"/proj/cdc/data/baby/2000/beam/unpacked/run%4.4d.root",run);
  sprintf(fname,"/proj/cdc/data/baby/2000/dedx/unpacked/run%4.4d.root",run);
  TFile file(fname);  // Input file

  jsf->SetInput(file);
  jsf->SetOutput(fout);

  Int_t nevent=jsf->Env()->GetValue("JSFSteer.Nevent",300);  
  Int_t minevt=1;
  Int_t maxevt=minevt+nevent;

  CDCRawHist      *hist  = new CDCRawHist();

  jsf->Initialize();
  CDCRawData *raw=(CDCRawData*)jsf->FindModule("CDCRawData");

  jsf->BeginRun(run);      // Set run number
  for(Int_t ev=minevt;ev<=maxevt;ev++){
    Int_t ib;
    if( ! (ib=jsf->GetEvent(ev)) ) break ;
    ((CDCRawDataBuf*)raw->EventBuf())->GetHeader()->DebugPrint();
    if( ! jsf->Process(ev) ) break ;
    jsf->FillTree();
    jsf->Clear();
  }

  jsf->Terminate();
  fout.Write();

}
