#include <stdio.h>
#include <time.h>

#include "daq.h"

int bitdisp(short int c)
{
    short int i, wc;
   
    for (i = 15; i >= 0; i--) {
        wc = (c >> i) & 0x01;
        printf("%d", wc);
    }
    printf("\n");
}

void main(int argc, char **argv)
{
    FILE *filed = NULL;
    int run_number;
    char filename[FILE_NAME_LENGTH];
    int i;
    int now;
    short int fid, nor, typ, nev;
    unsigned short int buf1, buf2;
    int j, jmax;
    int event = 0;
    int flag;

    /*
     * =-=-=-=-=- Open DST file
     */
    if (argc <= 1) {
        printf("Please input Run number[integer]: ");
        scanf("%d", &run_number);
    } else {
        run_number = atoi(argv[1]);
    }
    sprintf(filename, "Run%5.5d.dst", run_number);
    if ((filed = fopen(filename, "r")) == NULL) {
        exit(2);
    }

    /*
     * =-=-=-=-=- Read/Write buffer
     */
    while(1){
        fread((char *) &now, 4, 1, filed);
        fread((char *) &fid, 2, 1, filed);
        fread((char *) &typ, 2, 1, filed);
        fread((char *) &nor, 2, 1, filed);
        fread((char *) &nev, 2, 1, filed);
        printf("run %d, word %d, type %d ev %d\n", nor, now, typ, event);

        if (typ < 0) {         /* error event */
            event++;
            for (j = 0; j < now - 6; j++) {
                fread((char *) &buf1, 2, 1, filed);
            }
        } else if (typ == 1) { /* start comment */
            for (j = 0; j < now - 6; j++) {
                fread((char *) &buf1, 2, 1, filed);
            }
        } else if (typ == 2) { /* end comment */
            for (j = 0; j < now - 6; j++) {
                fread((char *) &buf1, 2, 1, filed);
            }
            break;
        } else {              /* normal event */

            j = 0;
            do {
                fread((char *) &buf1, 2, 1, filed); j++;
                fread((char *) &buf2, 2, 1, filed); j++;
                if (buf1 & 0x8000) {
                	printf("SADC %2.2d %2.2d %3.3d\n",
                               ((buf1 >> 11) & 0x1F),
                               ((buf2 >> 12) & 0x0F), 
                               (buf1 & 0x07ff));                    
                } else {
                        printf("FADC %2.2d %2.2d %4.4d %3.3d\n",
                               ((buf1 >> 11) & 0x1F),
                               ((buf2 >> 12) & 0x0F), 
                               (buf2 & 0x0fff),
                               (buf1 & 0x07ff));
                }
            } while (j < now - 6);

            event++;
        }
    }
}
