//*************************************************************************
//* ================
//*  DynArray3 Class
//* ================
//*
//* (Description)
//*    DynArray3 class supplies a functionality of a 3-dim array
//*    which has a variable size in each dimension.
//* (Requires)
//* 	TObjArray:
//* (Provides)
//* 	class DynArray3
//* (Update Recored)
//*    2000/05/17  K.Fujii	Original very primitive version.
//*
//*************************************************************************
//
#include "DynArray3.h"
#include <iostream.h>
//_____________________________________________________________________
//  -------------------------
//  3-dim Dynamic Array Class
//  -------------------------
//
ClassImp(DynArray3)

TObject * DynArray3::operator() (Int_t i, Int_t j, Int_t k) const
{
	return ((Dim *)((Dim *)At(i))->At(j))->At(k);
}

TObject *& DynArray3::Set(Int_t i, Int_t j, Int_t k)
{
	Dim *d1p = (Dim *)SafeAt(i);		// Force i to dimension 1
	if (!d1p) {				// If no 2nd dim. at i
		d1p = new Dim();		// create one
		AddAt(d1p,i);			// and add it to i.
	}
	Dim *d2p = (Dim *)d1p->SafeAt(j);	// Force j to dimension 2
	if (!d2p) {				// If no 3rd dim. at j
		d2p = new Dim();		// create one
		d1p->AddAt(d2p,j);		// and add it to j.
	}
	d2p->SafeAt(k);				// Force k to dimension 3

	return d2p->operator[](k);
}
